//+------------------------------------------------------------------+
//|                                                       SumRSI.mq5 |
//|                                        Copyright  2008, jax1000 |
//|                                                  jax1000@list.ru |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2008, jax1000"
//----  
#property link      "jax1000@list.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----        
#property indicator_buffers 1
//----    
#property indicator_plots   1
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|     SumRSI       |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----        DarkOrange 
#property indicator_color1  clrDarkOrange
//----   1 -  
#property indicator_style1  STYLE_SOLID
//----    1  3
#property indicator_width1  3
//----    
#property indicator_label1  "SumRSI"
//+----------------------------------------------+
//|     |
//+----------------------------------------------+
#property indicator_level1 70.0
#property indicator_level2 50.0
#property indicator_level3 30.0
#property indicator_levelcolor clrBlue
#property indicator_levelstyle STYLE_DASHDOTDOT
//+----------------------------------------------+
//|                   |
//+----------------------------------------------+
#property indicator_minimum   0
#property indicator_maximum 100
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint StartLength=3; //   
input uint EndLength=25; //                     
input ENUM_APPLIED_PRICE Applied_Price=PRICE_CLOSE; //  
input int Shift=0; //      
//+----------------------------------------------+

//----   ,    
//      
double SumRSIBuffer[];
//---- 
bool Init;
//----      
int RSI_Handle[];
//----      
int min_rates_total,xSize;
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+  
class CRSI
  {
public: double    m_RSI[];
  };
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
CRSI RSI[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----       
   if(StartLength>EndLength)
     {
      Init=false;
      Print("        !");
      return;
     }

//----     
   xSize=int(EndLength-StartLength+1);

   if(ArrayResize(RSI_Handle,xSize)<xSize)
     {
      Init=false;
      Print("      RSI_Handle[]!");
      return;
     }

   if(ArrayResize(RSI,xSize)<xSize)
     {
      Init=false;
      Print("       RSI[]!");
      return;
     }
   else Init=true;

//----         
   for(int count=0; count<xSize; count++) ArraySetAsSeries(RSI[count].m_RSI,true);

//----    iRSI
   for(int count=0; count<xSize; count++)
     {
      RSI_Handle[count]=iRSI(NULL,PERIOD_CURRENT,StartLength+count,Applied_Price);
      if(RSI_Handle[count]==INVALID_HANDLE)
        {
         Print("      iRSI");
         Init=false;
         return;
        }
     }

//----     
   min_rates_total=int(EndLength);

//----      
   SetIndexBuffer(0,SumRSIBuffer,INDICATOR_DATA);
//----    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----        min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(SumRSIBuffer,true);

//----      
   string shortname;
   StringConcatenate(shortname,"SumRSI(",StartLength,", ",EndLength,", ",Shift,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(!Init || rates_total<min_rates_total) return(RESET);
   for(int count=0; count<xSize; count++) if(BarsCalculated(RSI_Handle[count])<rates_total) return(RESET);

//----    
   int limit,bar,to_copy;
   double Sum;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-min_rates_total-1; //      
     }
   else limit=rates_total-prev_calculated; //      

   to_copy=limit+1;
//----       RSI[count].m_RSI[]
   for(int count=0; count<xSize; count++) if(CopyBuffer(RSI_Handle[count],0,0,to_copy,RSI[count].m_RSI)<=0) return(RESET);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      Sum=0.0;
      for(int count=0; count<xSize; count++) Sum+=RSI[count].m_RSI[bar];
      SumRSIBuffer[bar]=Sum/(EndLength-StartLength+1);
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
